class User {
  late String user_id;
  late String displayName;
  late String email;
  late double pendingPayment;
  late int pincode;
  late String apiToken;
  late String deviceToken;
  late String refreshToken;
  late String phoneNumber;
  late bool verifiedPhone;
  late String address;
  late Map<String, double> mapLocation = Map<String, double>();
  late bool auth;

  User();

  User.fromJSON(Map<String, dynamic> jsonMap) {
    user_id = (jsonMap['user_id'] ?? "").toString();
    displayName = jsonMap['name'] != null ? jsonMap['name'] : '';
    email = jsonMap['email'] != null ? jsonMap['email'] : '';
    pendingPayment = jsonMap['pending_payment'] != null
        ? double.parse(jsonMap['pending_payment'])
        : 0;
    pincode = jsonMap['pincode'] != null ? jsonMap['pincode'] : 0;
    phoneNumber =
        jsonMap['phone_number'] != null ? jsonMap['phone_number'] : '';
    apiToken = jsonMap['api_token'] ?? '';
    deviceToken = jsonMap['device_token'] ?? '';
    refreshToken = jsonMap['refreshToken'] ?? '';
    verifiedPhone = jsonMap['verifiedPhone'] ?? false;

    address = jsonMap['address'] ?? '';
    if (jsonMap['map_location'] != null) {
      mapLocation['latitude'] = jsonMap['map_location']['latitude'];
      mapLocation['longitude'] = jsonMap['map_location']['longitude'];
    }
  }

  Map toMap() {
    var map = new Map<String, dynamic>();
    map["user_id"] = user_id;
    map["displayName"] = displayName;
    map["email"] = email;
    map["phoneNumber"] = phoneNumber;
    map["pincode"] = pincode;

    map["api_token"] = apiToken;
    if (deviceToken != null) {
      map["device_token"] = deviceToken;
    }
    map["refreshToken"] = refreshToken;
    map["verifiedPhone"] = verifiedPhone;
    map["address"] = address;
    map["map_location"] = mapLocation;
    return map;
  }

  Map toRestrictedMap() {
    var map = new Map<String, dynamic>();
    map["user_id"] = user_id;
    map["displayName"] = displayName;
    map["email"] = email;
    map["phoneNumber"] = phoneNumber;
    map["refreshToken"] = refreshToken;
    map["address"] = address;

    return map;
  }

  @override
  String toString() {
    var map = this.toMap();
    map["auth"] = this.auth;
    return map.toString();
  }
}
